;This code must be compiled as a COM application.
;------------------------------------------------

CODESG SEGMENT PARA 'Code'
ASSUME CS:CODESG,DS:CODESG,SS:CODESG
       ORG 100h
EXIT		equ 1
CUST_CGEN	equ 2

MAKE_NEW_COLS	equ 10h
SYSFAIL_MODE	equ 20h
FALL_MATRIX	equ 40h
CURSOR		equ 80h
;-------------------------Commands--------------------------
; bit 0=1 - make cursor visible, reset videomode, restore regs and exit
; bit 1=1 - restore default cgen
; bit 2=0
; bit 3=0
;--------------------------Flags-----------------------------
; bit 4=1 - do make new cols in falling_cols
; bit 5=1 - it is system failure mode
; bit 6=1 - it is fall matrix words mode
; bit 7=1 - type with '' cursor}

begin:			;start from here
cld			;make sure of proper direction flag
call Init		;do initialization
mov ah,1                ;kill cursor
mov cx,0100h
int 10h
mov bl,0		;clrscr
call default
@nf:			;start choosing the effect to show
mov cx,1500             ;blank screen for 1,5 sec between effects
call delays
@nef:
call rand		;get a random number 16-bit number
cmp al,oldfunc 		;the next effect must differ from the previous effect
je  @nef
mov oldfunc,al		;store the new effect's number
test al,08h		;if bit 3=0 - do falling colomns
jz  @falls		;or if bit 3=1: other effects
  test al,04h		;if bit 2=1 - trace phone number, else write words
  jz  @word		
    and al,03h		;if bits 1 and 0 = 0, end effect with SYSTEM FAILURE
    jz  @mksf		;else do usual phone number seach
      and flg,not SYSFAIL_MODE	;clear bit of sysfail
      jmp @numbers
@mksf:
      or  flg,SYSFAIL_MODE	;set bit of sysfail
      jmp @numbers		;(this bit will be tested in effect)
@falls:
  test al,04h		;if bit 3=0 then make MATRIX word in the end
  jz  @fmt		;or simply do the usual falling colomns
    and flg,not FALL_MATRIX
    jmp short @nxf
@fmt:
    or flg,FALL_MATRIX	;set bit of falling MATRIX
@nxf:
  mov al,ah		;use the high byte of random number to choose the
  and ax,7Fh		;amount of iterations of falling colomns effect
  jz  @nef
  add al,30h
  jmp @fall_cols
@word:			;choose words typing
    and al,03h		;check lower 2 bits
    cmp al,3		;if al=3 then write "Have you ever..."
    je  @haveyou
    cmp al,2		;if al=2 then write "What is the Matrix?"
    je  @whtMtr		;else write "Wake up, Neo!"
;end effect choosing

;type "Wake up, Neo!"
;jmp @nf	;stopper of the effect (for debug purposes)
lea si,ln10	;type "Wake up, Neo!"
xor di,di	;at position 0,0
mov ax,50	;waiting 50 ms between letters
call typer
mov cx,3000	;wait for 3 sec.
call delays
xor di,di
call clrstr	;clear this string
mov cx,500
call delays
xor di,di	;type the next string at pos. 0,0
mov ax,80	;type slower
call typer
mov cx,5000	;wait 5 sec.
call delays
xor di,di
call clrstr
xor di,di
mov ax,50
call typer
mov cx,4000
call delays
xor di,di
call clrstr
jmp @nf		;go to next effect chooser ^^^

@whtMtr:	;type "What is the Matrix?"
;jmp @nf
mov ax,35
lea si,ln13
xor di,di
call typer
mov cx,200
call delays
mov ax,50
mov di,160	;type at position 0,1 (on the next line)
call typer
mov cx,4000
call delays
@z1:
mov bl,flg
and bl,0F0h
call default	;clrscr
jmp @nf

@haveyou:	;type "Have you ever had a dream, Neo?"
;jmp @nf	;stopper of the effect
lea si,ln15
xor di,di
mov ax,30
call typer
mov cx,10
call delays
lea si,ln16
mov di,160	;type on the second line
call typer
lea si,ln17
mov di,320	;type on the third line
call typer
mov cx,6000
call delays
jmp short @z1

;--------------------------------------------------------------------------

@numbers:	;effect of tracing phone number
;jmp @nf	;stopper of the effect
xor di,di
mov pass,di		;pass:=0;
or  flg,CURSOR		;set flag of custom cursor for "typer" procedure
mov reserve,-1
mov cx,10		;blink custom cursor 10 times
mov telnum,ch		;telnum:=0;
call blinks
mov ax,20		;type the first message
lea si,ln0
call typer		;"Call trans opt: received."
test flg,SYSFAIL_MODE	;"system failure" mode?
jnz @sfn		;the middle part of the first string was different
  call typer		;in cases when trace had succeeded and when it did not.
  add si,17		;So we have to write it correctly in each case.
  jmp short @log
@sfn:
  add si,17
  call typer
@log:
call typer		;finish the first string
mov cl,5		;blink 5 times
call blinks
xor di,di
call clrstr		;clear first string
xor di,di
test flg,SYSFAIL_MODE	;the following strings were different also in the cases
jz  @sfsk		;of number tracing.
  call typer		;"WARNING: carrier anomaly"
  mov cl,2
  call blinks
  xor di,di
  call clrstr
  jmp short @numon
@sfsk:
  add si,25		;or just skip this string
@numon:
xor di,di
call typer		;"Trace program: running"
mov cl,3
call blinks
xor ax,ax
call newnxt
xor ax,ax
lea si,tel
xor di,di	;on the first line we will write the phone number to find
mov cx,10	;but it will be written black letters on black background
@lpn:
  movsb
  stosb
loop @lpn
mov cl,70
rep stosw
;by now we are ready to prepare the rest of the screen and DI=160 (00A0h)
mov cx,1920-80	;no need to fill last line here
@fillscr:	;fill the rest of the screen with random numbers
  call mknum	;make any number "0"-"9" painted light or dark green
  stosw		;write this number on screen
loop @fillscr
@mainlp:	;start main loop
  push es	;do numbers scrolling down
  pop ds
  mov cx,1920-80
  mov di,4000-2;3998
  mov si,4000-(80*2)-2;3838
  std
  rep movsw
  cld
  push ss
  pop ds
  inc pass
  mov dx,pass
  cmp dx,nxt	;see if it's time to show a new number
  jb  @nonum
    test flg,SYSFAIL_MODE;is it sysfail mode?
    jz @notsf
      cmp pass,100	;when pass=100, freeze trace and write SYSTEM FAILURE
      jb  @sfcol
        call fill1line	;fills second line with random numbers and color
        lea si,ln7	;write the SYS Fail frame
        mov di,1760+62
        mov al,0Ah
        mov cl,3
@lpsys:   push cx
           mov cl,20
@getsys:     movsb	;copy symbol
             stosb	;write color from al
           loop @getsys
          pop cx
          add di,120
        loop @lpsys
        mov cx,5000	;then wait for 5 sec
        call delays
@nfend:		;and finish effect
        and flg,not CURSOR
        mov bl,0
        call default	;clrscr
        jmp @nf		;go to choose a new effect ^^^
@sfcol:			;if it is SYSFAIL mode and we need to make that one
      mov di,160	;colomn which was found
      xor ax,ax
      mov cx,240	;make black colomns
@sfclp: stosw
        add di,14
      loop @sfclp
      jmp short @nonum
@notsf:			;now if it's not SYSFAIL mode
    xor ax,ax
    lea bx,que		;find out which number is found
    mov al,telnum
    inc telnum		;update telnum
    push ax
     xlat
     mov di,ax
     add di,di	;DI*2	;get offset of the found number's color
     inc di
     mov al,0Ah		;paint found number light green
     stosb
     add di,158
     xor ax,ax
     mov cl,192
@lppx: stosw		;paint the black colomns under found number
       add di,18
     loop @lppx
    pop ax
    call newnxt
@nonum:
  call fill1line
  cmp telnum,10	;done with telnum?
  jb  @sfd
    mov cx,255
    call delays	;wait
    mov ax,20
    lea si,ln6	;write last string
    mov di,160
    call typer
    mov cl,6
    call blinks
    jmp short @nfend
@sfd:
  mov cx,50	;wait before next iteration
  call delays
jmp @mainlp

newnxt proc
  lea bx,tm	;array of moments when each number is found
  xlat
  add ax,ax	;ax*2
  mov nxt,ax	;nxt will keep the moment when the next number will be shown
  ret
newnxt endp

fill1line proc
  mov di,160	;create new upper line with random numbers and colors
  mov cx,80
@s2:
    xor ax,ax
    repe scasw
    je  @ret	;if number's color isn't black, make a new number for it
      call mknum
      mov es:[di-2],ax
      jmp short @s2
@ret:
  ret
fill1line endp

mknum proc
;it returns a random number (30h-39h) in AL and 0A (light green) or 02 (dark green) in AH
;this makes up a ready char and color to go into video memory
push dx
xor dh,dh
mov dl,cnt0A    ;count of light green chars. they come out every random time
mov ah,-1
mov al,reserve
cmp al,ah	;if reserve (from previous call) has nothing (-1)
jne @res	;then make a new number
  call rand
  mov ah,0
  call sepbyte
@res:
add al,dl
mov reserve,ah
or  dl,dl
jne @na
  mov ah,0Ah
  mov dl,al
  xor dl,ah
  jmp short @nb
@na:
  mov ah,02h
  dec dx
@nb:
cmp al,10
jb  @out9
  sub al,10
  jmp short @nb
@out9:
add al,30h
mov cnt0A,dl
pop dx
ret
mknum endp

blinks proc;DI: offset in videomem at which the blink char will appear
           ;CX: how many times it should blink
;for gradual blink we use an array of chars in "bln",
;each char is shown during the respective period in the "per" array
push ax
push bx
push cx
push si
jcxz @out	;make sure the blinking times is not 0
mov ah,0Ah  ;set it to light green color
lea si,bln
lea bx,per
@lp:
  push cx
  push bx
  push si
  mov cx,9
@@1:lodsb		;get sym to show (color is always the same in AH)
    mov es:[di],ax	;write it on the screen
    push cx
      mov cl,[bx]	;in CL set the period to show the char
      inc bx
      call delays
    pop cx
  loop @@1
  pop si
  pop bx
  pop cx
loop @lp
@out:
pop si
pop cx
pop bx
pop ax
ret
blinks endp

;---------------------------------------------------------------------------

@fall_cols:
;jmp @nf
;make iterations and other data for falling cols
mov nxt,ax		;do iterations until ps=nxt
mov oldsp,sp      ;we generate the real chargen in stack
xor ax,ax
mov pass,ax	      ;amount of iterations made (now = 0)
mov cx,ax
push ds
pop es
or  flg,MAKE_NEW_COLS	;set bit of new colomns making
mov dx,38
sub sp,38*16		;reserve room in stack for full cgen
lea si,newsym
mov di,sp
@nxcg:	;ss==ds		;prepare full cgen in stack
  stosw
  mov cl,5
  rep movsw
  stosw
  stosw
dec dx
jnz @nxcg
push bp			;now prepare and install new cgen}     
 mov bp,sp		;Offset of new bitmap for cgen
 add bp,2		;don't include old BP in cgen!
 mov cx,38	;amount of characters to change
 mov dx,180	;start with character number...
 mov bx,1000h	;BL:=0: Change table 0
		;BH:=10h: 16 bytes per character
 mov ax,1100h	;AH:=11h: Function = LOAD CHARACTER GENERATOR
		;AL:=00h: Subfunction = CUSTOM CHAR GEN
 int 10h	;Use BIOS videoservice to replace characters
 or  flg,CUST_CGEN	;set bit of custom cgen
pop bp
mov sp,oldsp	;clear stack
mov cx,2000	;fill up the screen with random syms and atr:=0
mov ax,0B800h
mov es,ax
xor di,di
@lp0:
  call getsym
  stosw
loop @lp0
@x1:		;we scroll only attributes
mov cx,2000-80	;amount of syms
mov di,4000-2	;3998
mov si,4000-(80*2)-2	;3838
@scrl:
  mov ax,es:[si]
  test flg,FALL_MATRIX	;if it's not fall words mode, go straight to copy it
  jz  @dor
    test flg,MAKE_NEW_COLS	;do we still make new cols?
    jnz @dor
      cmp cx,843		;this is to avoid scrolling "MATRIX"
      ja  @dor			;word with the rest of the screen
        cmp cx,757		;when it reaches its final position
        jb  @dor
          cmp cx,837
          jae @nf5
            cmp cx,763
            ja  @dor
              mov al,es:[di]
@nf5:         cmp al,170
              jb  @nor
@dor:
  mov es:[di+1],ah
@nor:
  sub si,2
  sub di,2
loop @scrl
mov ax,cx	;we'll need the 0 in AH many times below
;here we are updating line one column status. later new colomns will be
;started according to this data
@lp1:
   mov bx,offset bf
   add bx,cx	;get bf[i]
   mov al,[bx]	;!you'll need this [bx+cx] later too! Don't change code here.
   or  al,al
   jnz @nz
     test flg,MAKE_NEW_COLS
     jz   @wr		;don't make data about empty cols
     push cx
     jmp short @wr
@nz:
   test al,0F0h
   jnz @nF0
@np: xor ax,ax		;if bf[i]=?0h (the col count is over) ;it's out already
     mov [bx],al	;then bf[i]:=0;
     jmp short @wr	;and paint it black
@nF0:
   test al,0Fh
   jz @np
     dec ax
     mov [bx],al
     mov al,2
@wr: mov di,cx
     add di,di	;DI*2
     inc di
     stosb	;mov es:[di],al
@fllout:
  inc cx
cmp cl,80
jb @lp1
test flg,MAKE_NEW_COLS	;still need to make new colomns?
jz @ddxz		;or else are we finishing the effect
  mov ax,pass
  cmp ax,nxt
  jne  @d2n
    and flg,not MAKE_NEW_COLS
    xor cx,cx
    mov pass,cx
    mov cl,18
    lea si,col0	;prepare cols in empbf
    lea di,colbf
    push es
     push ds
     pop es
     rep movsw
    pop es
@d2n:
    call @2nd
    call @2nd
    jmp short @nocols
@ddxz:
test flg,FALL_MATRIX
jnz  @dowd
  cmp pass,40
  ja @end
@nocols:
    mov cx,60
    call delays
    inc pass		;update counter
    mov sp,oldsp	;now clear empbf[0] which is in stack
    jmp @x1		;and jump up to make another scroll
@end:
    mov sp,oldsp
    mov bl,flg
    and bl,10000110b
    call default
    jmp @nf
@dowd:
    lea bx,col0
    lea si,colbf
    mov cx,6
    xor ah,ah
@matlp:
      mov al,[si]	;check if it's time for the col to come out
      cmp ax,pass
      ja  @mtskp	;don't work with it
        mov di,[si+4]	;get starting address on line 0 of the new col
        mov al,[si+1]
        or  al,al	;did it fall all the way (al=0?)
        jne @docol
          or  di,di
          je  @mtskp
            cmp di,1670	;is the falling letter already in place
            ja  @stopsnk
              call movesnk
              jmp short @mtskp
@stopsnk:     inc di
              mov byte ptr es:[di],0Ah		;paint 'M' 0A
              xor ax,ax
              mov es:[di+160],ah	;paint under it 00 against attr scrolling
              mov [si+4],ax
              jmp short @mtskp
@docol: dec byte ptr [si+1]
        call sepbyte
        cmp al,ah		;just started col?
        jne @doingcol
           mov dl,es:[di]	;save old letter
           mov dh,[si+3]	;get new letter
           and dh,01111111b	;prepare 'M'
           mov [si+2],dx
           mov dl,dh
           mov dh,0Ah
           mov es:[di],dx
           shr di,1
           mov [di+offset bf],ah
           jmp short @mtskp
@doingcol:
        call movesnk
        mov di,[bx+4]	;keep making snake
        inc di
        mov byte ptr es:[di],02h
        or  al,al	;cmp al,ch
        jne @mtskp	;ja  @mtskp
          mov [si+1],al
          stosb		;mov es:[di],al
@mtskp:
      mov ax,6
      add si,ax
      add bx,ax
    loop @matlp
  cmp pass,60
  jb  @22
  jmp @end
@22:
  jmp @nocols

@2nd:		;insert a new random col and change a random symbol on
mov ax,oldsp	;the screen
mov bx,sp
add bx,2
sub ax,bx	;get amount of empty cols
call randdiap	;get a member of empbf array to insert a new col
and al,0FEh	;make sure ax is divisible by 2
xlat		;get value of empbf[i]
mov di,ax
call rand
and al,0Fh
mov ah,al
mov cl,4
shl al,cl
add al,ah
mov [di+offset bf],al	;bf[i]:=random(0..255)
mov al,0Ah
add di,di	;shl di,1
inc di
stosb
call rand
mov cx,4000
and ax,2FFEh	;ax:=ax<=16380
  cmp ax,cx
  jb  @nokk
@sub:
  sub ax,cx
  jae @sub
@nokk:
mov di,ax
call getsym	;randomize some chars on the screen
stosb
ret

movesnk proc	;is used twice in Falling Cols to move a letter-snake (MATRIX)
push ax
 mov ax,[si+2]
 mov es:[di],al
 add di,160
 mov [si+4],di
 mov al,es:[di]	;save new sym
 mov [si+2],al
 mov es:[di],ah
 xor ax,ax
 mov es:[di+161],al
pop ax
ret
movesnk endp

getsym proc	;get a new random matrix symbol to insert (return in AX=00??h)
@symagain:
mov ax,0B4D9h
call randdiap
cmp al,telnum
je  @symagain
mov telnum,al
ret
getsym endp

;----------------------------------------------------------------------
;----------------------Data Segment here-------------------------------
newsym  db 008h,008h,0FEh,088h,088h,088h,084h,084h,0A4h,0C2h
	db 010h,010h,0FEh,010h,054h,054h,092h,092h,010h,010h
	db 082h,082h,082h,082h,080h,040h,040h,040h,030h,00Eh
	db 0FEh,080h,080h,080h,080h,040h,040h,020h,018h,006h
	db 0FEh,000h,000h,0FEh,080h,080h,040h,040h,030h,00Eh
	db 010h,010h,0F0h,048h,044h,042h,020h,020h,018h,006h
	db 0FEh,080h,080h,080h,080h,040h,040h,020h,058h,086h
	db 048h,048h,0FEh,048h,048h,048h,040h,020h,020h,018h
	db 0FEh,080h,080h,080h,080h,048h,050h,020h,058h,086h
	db 010h,010h,0F8h,088h,084h,082h,040h,040h,020h,018h
	db 008h,008h,008h,008h,004h,004h,044h,044h,0BAh,086h
	db 0FEh,080h,080h,048h,048h,038h,008h,004h,004h,002h
	db 010h,010h,0FEh,080h,040h,040h,030h,05Eh,090h,010h
	db 010h,010h,0FEh,010h,010h,010h,0FEh,010h,010h,010h
	db 08Ah,08Ah,08Ah,08Ah,040h,040h,040h,020h,010h,00Eh
	db 080h,080h,084h,048h,050h,020h,060h,090h,008h,006h
	db 010h,010h,0F8h,088h,084h,08Ah,050h,040h,030h,00Ch
	db 0FEh,010h,010h,010h,010h,010h,010h,010h,010h,0FEh
	db 07Ch,000h,0FEh,020h,020h,020h,010h,010h,008h,006h
	db 040h,040h,0FEh,060h,050h,050h,048h,044h,052h,060h
	db 0FEh,008h,008h,008h,0FEh,008h,008h,008h,008h,0F0h
	db 09Eh,080h,080h,09Eh,080h,080h,040h,040h,030h,00Eh
	db 002h,002h,002h,0C2h,032h,00Eh,002h,002h,002h,0FCh
	db 008h,008h,0FEh,088h,048h,048h,008h,008h,008h,008h
	db 004h,004h,004h,0C4h,0B4h,04Eh,044h,004h,004h,0F8h
	db 010h,010h,0FEh,082h,082h,082h,040h,040h,030h,00Eh
	db 0FEh,080h,080h,080h,080h,080h,080h,080h,080h,0FEh
	db 000h,0FEh,080h,080h,044h,048h,030h,020h,040h,040h
	db 09Eh,080h,080h,080h,080h,040h,040h,020h,018h,006h
	db 080h,080h,080h,080h,080h,040h,040h,020h,018h,006h
	db 010h,010h,010h,010h,030h,0D0h,010h,010h,010h,010h
	db 020h,020h,0FEh,020h,020h,010h,010h,010h,008h,006h
	db 0FEh,000h,000h,000h,07Ch,000h,000h,000h,000h,0FEh
	db 0FEh,080h,080h,080h,0FEh,080h,080h,080h,080h,0FEh
	db 0FEh,002h,002h,07Eh,082h,080h,080h,080h,082h,07Ch
	db 07Ch,082h,082h,082h,082h,0FCh,080h,080h,042h,03Ch
	db 07Ch,082h,082h,080h,040h,020h,010h,008h,084h,0FEh
	db 010h,010h,010h,010h,010h,010h,010h,010h,010h,010h
tel  db ' 25550690 '
que  db 9,4,1,2,3,6,0,8,7,5
col0 db 08,44h,0,0CDh,4Ah,0
col1 db 26,66h,0,0C1h,4Ch,0
col2 db 00,77h,0,0D4h,4Eh,0
col3 db 22,99h,0,0D2h,50h,0
col4 db 05,55h,0,0C9h,52h,0
col5 db 15,66h,0,0D8h,54h,0
tm   db 30,50,76,95,101,110,130,153,169,207
bln  db ' ۲ '
per  db 100,20,20,20,150,20,20,20,100
ln0  db 26,'Call trans opt: received. '
ln1  db 16,'2-19-98 13:24:18'
ln2  db 16,'9-18-99 14:32:21'
ln3  db  9,' REC:Log>'
ln4  db 24,'WARNING: carrier anomaly'
ln5  db 22,'Trace program: running'
ln6  db 15,'Trace completed'
ln7  db ' Ŀ '
ln8  db '  SYSTEM FAILURE  '
ln9  db '  '
ln10 db 15,'Wake up, Neo...'
ln11 db 21,'The Matrix has you...'
ln12 db 24,'Follow the white rabbit.'
ln13 db 19,'What is the Matrix?'
ln14 db 80,'It is the world that has been pulled over your eyes to blind you from the truth.'
ln15 db 80,'Have you ever had a dream, Neo, that you were so sure was real? What if you were'
ln16 db 77,'unable to wake from that dream? How would you know the difference between the'
ln17 db 31,'dream world and the real world?'
f10 db  4,'HELP'
f11 db 65,'Press any key to exit the program. F1 brings up this help screen.'
f12 db  5,'ABOUT'
f13 db 80,'This program is titled "MATRIX". It is a screensaver for DOS. Its theme is based'
f14 db 77,'on the "Matrix" movie. I tried to follow the screen effects from the movie as'
f15 db 46,'close as I could in 25X80, 16 color text mode.'
f16 db 79,'This program is freeware. No charges may be taken for it. It may be distributed'
f17 db 76,'on the "AS IS" basis only. No changes may be applied to it without a written'
f18 db 27,'permission from the author.'
f19 db 74,'"MATRIX" (this screen saver) was created by Sergey Solodovichenko in 2001.'
f20 db 78,'The entire program was written in Assembler language for 8086/8088 processors.'
f21 db 50,'It requires though a VGA adapter to work properly.'
f22 db 75,'The program delay routine was based on DELAY from CRT unit in Turbo Pascal.'
f23 db 75,'Even though no destructive effect was intended for this program, the author'
f24 db 75,'cannot be held responsible for any damage this program may cause. Use it at'
f25 db 15,'your own risk.'
;---------------vars----------------
mode	db 3		;store old videomode
bf     	db 80 dup (0)
colbf  	db 36 dup (0)	;80 dup (0)
oldsp   dw 0
pass	dw 0
nxt	dw 0
delaycntlo dw 0
delaycnthi dw 0
cursize dw 0
oldfunc db 0          	;save previous choice of effect to show
cnt0A	db 0
reserve db 0
telnum  db 0
rds 	db 5Ah
lastnum db 0
flg	db 0		;commands and flags in flg
;-------------------------Commands--------------------------
; bit 0=1 - make cursor visible, reset videomode, restore regs and exit
; bit 1=1 - restore default cgen
; bit 2=0
; bit 3=0
;--------------------------Flags-----------------------------
; bit 4=1 - do make new cols in falling_cols
; bit 5=1 - it is system failure mode
; bit 6=1 - it is fall matrix words mode
; bit 7=1 - type with '' cursor}
;----------------------End Data Segment area-----------------------

delays proc	;amount of msec to wait transferred to it straight in CX
jcxz	@outd2
push    es
push    ax
push    bx
push    dx
push    di
xor     ax,ax
mov	es,ax
mov     di,0400h
mov	bl,es:[di]
@nlp1:
call    keyx	;check if a key was pressed during waiting
mov     ax,DelayCntLo
mov     dx,DelayCntHi
call	delayloop;wait some short time
loop	@nlp1
pop     di
pop     dx
pop     bx
pop     ax
pop     es
@outd2:
ret
delays endp

;main delay function
delayloop proc
@ag1:
sub	ax,1
sbb	dx,0
jc	@oudl2
cmp	bl,es:[di]
je	@ag1
@oudl2:
ret
delayloop endp

Init proc	;Initializes delays, help screen etc.
mov ah,3
mov bh,0
int 10h
mov cursize,cx
xor ax,ax
mov flg,al
mov es,ax
mov al,3
xchg al,es:[0449h]	;save orig videomode
mov mode,al		;set mode 3 (text, 25X80, 16 colors)
mov di,046Ch
mov bl,es:[di]
@00:
cmp bl,es:[di]
je  @00
inc bl
mov ax,-28
cwd
call delayloop
not ax
not dx
mov bx,ax
mov ax,dx
xor dx,dx
mov cx,55
push cx
div cx
mov DelayCntHi,ax
mov ax,bx
pop cx
div cx
mov DelayCntLo,ax	;end delay init
mov ax,0B800h		;save previous screen
push ds			;on another screen page (page number 3)
 mov es,ax
 mov ds,ax
 mov di,3000h
 xor si,si
 mov cx,2000
 rep movsw
pop ds
mov di,104Ah		;make the help screen on page 1
lea si,f10
xor ax,ax
call typer
mov di,1140h
call typer
mov di,1000h+640+74
call typer
mov di,1000h+160*5
mov cx,13
@nxl:
  push di
   call typer
  pop di
  add di,160
loop @nxl
ret
;now we are ready to work on page 0
Init endp

;separates high and low halfbytes of AL into AH and AL
sepbyte proc
push cx
 xor ah,ah
 mov cx,4
 shl ax,cl
 shr al,cl
pop cx
ret
sepbyte endp

default proc;
push cx
push ax
push dx
xor cx,cx
mov ax,0600h	;clrscr
push bx
 mov bh,2	;BH:=attr
 mov dx,184Fh
 int 10h
pop ax
push ax
 test al,2
 jz  @nocg
   mov bl,00h	;BL:=0:   Change table 0}
   mov ax,1104h ;AH:=11h: Function = LOAD CHARACTER GENERATOR
                ;AL:=04h: Subfunction = DEFAULT CHAR GEN
   int 10h      ;Use BIOS to replace next character
   and flg,not CUST_CGEN	;custom cgen bit:=OFF
@nocg:
pop bx
test bl,EXIT	;need to restore regs and exit the program?
jz  @noreg
  push ds
   mov si,0B800h	;return the original screen back to page 0
   mov es,si
   mov ds,si
   mov si,3000h
   xor di,di
   mov cx,2000
   rep movsw
  pop ds
  mov ah,1	;restore normal visible cursor
  mov cx,cursize
  int 10h
  xor ax,ax
  mov es,ax
;  mov es:[0450h],ax	;set cursor to coord:0,0 (for the first videopage)
  mov dl,mode		;restore orig video mode
  mov es:[0449h],dl
  int 20h		;end status restoring
@noreg:
pop dx
pop ax
pop cx
ret
default endp

;generates a number byte in al
rand proc
push bx
push es
push cx
xor bx,bx
mov cx,bx
mov es,bx
@1q:
mov bl,rds	;this value changes all the time
mov cl,es:[046Ch]	;get current timer value
inc bx
cmp bl,211	;rds cannot be larger than 211
jb  @2q
  xor bx,bx
@2q:
mov rds,bl
add bx,cx
mov ax,[bx+100h]	;now get a word at [rds+timer_value+100h] (from code)
add ax,cx	;add timer_value to retrieved word
and cl,7	;now we will roll bits
rol ax,cl	;of the value several times
xor al,bl
cmp al,lastnum
je  @1q
mov lastnum,al
pop cx
pop es
pop bx
ret
rand endp

;create a random number from the given range
randdiap proc	;send AH:=btm, AL:=top; get randnum in al
push bx   	;save BX
  mov bx,ax
  cmp bl,bh
  ja  @ok
    mov al,bl    ;randbyte:=top
    jmp short @outn
@ok:call rand
    sub bl,bh
@chkn:
    cmp al,bl
    jbe @outs0
      sub al,bl
      jmp @chkn
@outs0:
  add al,bh
@outn:
mov ah,0
pop bx
ret
randdiap endp

;check for pressed key
;if any key but not F1 then exit
;if F1 then show Help screen (it is created on videopage 1 upon program init)
keyx proc	;F1 - help, any other key - exit program
push ax
 mov ah,1	;check keypressed
 int 16h
 jz  @keyc	;if ZF=1 then no new key
   xor ax,ax
   int 16h
   cmp ah,3Bh 	;if it is F1
   je @F1h	;jump to @F1
     mov bl,flg	;else kill program
     or  bl,EXIT
     call default	;kill the program here
     ;program exits to DOS in the previus call
@F1h:
     mov ax,0501h	;switch to page 1 with help screen
     push ax
      int 10h
      mov ax,0C00h	;clear keyboard buffer
      int 21h
      xor ax,ax   	;wait for a key stroke
      int 16h
     pop ax      	;restore page 0 with current effect
     dec ax
     int 10h
@keyc:
pop ax
ret
keyx endp

;this proc types a string one symbol at a time 
typer proc	;AX=delay bwn letters
 		;SI=offset of the string to type
		;DI=offset on the screen
push cx
push bx
mov bx,0ADBh
xor cx,cx
mov cl,[si]	;get length of the string
inc si
@lp0F:
  movsb
  mov es:[di],bh
  inc di
  test flg,CURSOR  ;if CURSOR flag is set then type "" cursor after letter
  jz @noc
    mov es:[di],bx
@noc:
  push cx
    mov cx,ax
    call delays
  pop cx
loop @lp0F
pop bx
pop cx
ret
typer endp

;this proc clears one line on the screen
clrstr proc ;DI:=number of line to clear
push ax
push cx
mov ax,0A20h
mov cx,80
rep stosw
pop cx
pop ax
ret
clrstr endp

CODESG ENDS
END begin

;this is full cgen that will be created in stack upon loading
;newsym  db 000h,000h,008h,008h,0FEh,088h,088h,088h,084h,084h,0A4h,0C4h,000h,000h,000h,000h
;nn1     db 000h,000h,010h,010h,0FEh,010h,054h,054h,092h,092h,010h,010h,000h,000h,000h,000h
;nn2     db 000h,000h,082h,082h,082h,082h,080h,040h,040h,040h,030h,00Eh,000h,000h,000h,000h
;nn3	db 000h,000h,0FEh,080h,080h,080h,080h,040h,040h,020h,018h,006h,000h,000h,000h,000h
;nn4 	db 000h,000h,0FEh,000h,000h,0FEh,080h,080h,040h,040h,030h,00Eh,000h,000h,000h,000h
;nn5	db 000h,000h,010h,010h,0F0h,048h,044h,042h,020h,020h,018h,006h,000h,000h,000h,000h
;nn6	db 000h,000h,0FEh,080h,080h,080h,080h,040h,040h,020h,058h,086h,000h,000h,000h,000h
;nn7 	db 000h,000h,048h,048h,0FEh,048h,048h,048h,040h,020h,020h,018h,000h,000h,000h,000h
;nn8	db 000h,000h,0FEh,080h,080h,080h,080h,048h,050h,020h,058h,086h,000h,000h,000h,000h
;nn9     db 000h,000h,010h,010h,0F8h,088h,084h,082h,040h,040h,020h,018h,000h,000h,000h,000h
;nn10	db 000h,000h,008h,008h,008h,008h,004h,004h,044h,044h,0BAh,086h,000h,000h,000h,000h
;nn11 	db 000h,000h,0FEh,080h,080h,048h,048h,038h,008h,004h,004h,002h,000h,000h,000h,000h
;nn12	db 000h,000h,010h,010h,0FEh,080h,040h,040h,030h,05Eh,090h,010h,000h,000h,000h,000h
;nn13	db 000h,000h,010h,010h,0FEh,010h,010h,010h,0FEh,010h,010h,010h,000h,000h,000h,000h
;nn14	db 000h,000h,08Ah,08Ah,08Ah,08Ah,040h,040h,040h,020h,010h,00Eh,000h,000h,000h,000h
;nn15	db 000h,000h,080h,080h,084h,048h,050h,020h,060h,090h,008h,006h,000h,000h,000h,000h
;nn16	db 000h,000h,010h,010h,0F8h,088h,084h,08Ah,050h,040h,030h,00Ch,000h,000h,000h,000h
;nn17	db 000h,000h,0FEh,010h,010h,010h,010h,010h,010h,010h,010h,0FEh,000h,000h,000h,000h
;nn18	db 000h,000h,07Ch,000h,0FEh,020h,020h,020h,010h,010h,008h,006h,000h,000h,000h,000h
;nn19	db 000h,000h,040h,040h,0FEh,060h,050h,050h,048h,044h,052h,060h,000h,000h,000h,000h
;nn20	db 000h,000h,0FEh,008h,008h,008h,0FEh,008h,008h,008h,008h,0F0h,000h,000h,000h,000h
;nn21	db 000h,000h,09Eh,080h,080h,09Eh,080h,080h,040h,040h,030h,00Eh,000h,000h,000h,000h
;nn22	db 000h,000h,002h,002h,002h,0C2h,032h,00Eh,002h,002h,002h,0FCh,000h,000h,000h,000h
;nn23	db 000h,000h,008h,008h,0FEh,088h,048h,048h,008h,008h,008h,008h,000h,000h,000h,000h
;nn24	db 000h,000h,004h,004h,004h,0C4h,0B4h,04Eh,044h,004h,004h,0F8h,000h,000h,000h,000h
;nn25	db 000h,000h,010h,010h,0FEh,082h,082h,082h,040h,040h,030h,00Eh,000h,000h,000h,000h
;nn26	db 000h,000h,0FEh,080h,080h,080h,080h,080h,080h,080h,080h,0FEh,000h,000h,000h,000h
;nn27	db 000h,000h,000h,0FEh,080h,080h,044h,048h,030h,020h,040h,040h,000h,000h,000h,000h
;nn28	db 000h,000h,09Eh,080h,080h,080h,080h,040h,040h,020h,018h,006h,000h,000h,000h,000h
;nn29	db 000h,000h,080h,080h,080h,080h,080h,040h,040h,020h,018h,006h,000h,000h,000h,000h
;nn30	db 000h,000h,010h,010h,010h,010h,030h,0D0h,010h,010h,010h,010h,000h,000h,000h,000h
;nn31	db 000h,000h,020h,020h,0FEh,020h,020h,010h,010h,010h,008h,006h,000h,000h,000h,000h
;nn32	db 000h,000h,0FEh,000h,000h,000h,07Ch,000h,000h,000h,000h,0FEh,000h,000h,000h,000h
;nn33	db 000h,000h,0FEh,080h,080h,080h,0FEh,080h,080h,080h,080h,0FEh,000h,000h,000h,000h
;nn34	db 000h,000h,0FEh,002h,002h,07Eh,082h,080h,080h,080h,082h,07Ch,000h,000h,000h,000h
;nn35	db 000h,000h,07Ch,082h,082h,082h,082h,0FCh,080h,080h,042h,03Ch,000h,000h,000h,000h
;nn36	db 000h,000h,07Ch,082h,082h,080h,040h,020h,010h,008h,084h,0FEh,000h,000h,000h,000h
;nn37	db 000h,000h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,000h,000h,000h,000h